-- Detection of bosses is done by:

-- *********************************************************
-- **                  Deadly Boss Mods                   **
-- **            http://www.deadlybossmods.com            **
-- *********************************************************

-- This addon links the combatstart and combatend functions of DBM to determen which boss is been fighten.
-- Thanks to the detection system by 'Deadly Boss Mods', this addon can activate the debuffwatchers that are of intrest during the fight.
-- Unfortunatly my addon can only show 2 debuffs at the time so some debuffs share posistions with a priority system.

RPT_RF_DBM_SaveFunc = nil;

function RPT_RF_DBM_WipeInfo(info)
	info.flash_debuff = false;
	info.flash_b = 0;
	info.showHealth = true;
	info.frame.Dead:SetTextColor(1,1,1);
	
	if not info.flash_agro then
		info.flash = false;
	end
	
	-- deactivate the personal debuffs.
	for k,v in pairs(info.debuffs) do
		-- deactivate the debuffs:
		local dInfo = RPT_Debuffs2[k];
		
		if v and dInfo.deactivate then
			local unit = info.player;
			
			if info.vehicle then
				unit = info.vUnit;
			end
			
			dInfo.deactivate(unit,dInfo,info);
		end
	end
	
	-- wipe the personal debuffs.
	table.wipe(info.debuffs);

end

function RPT_RF_DBM_EF_WipeInfo()
	local max = RPT_ExtraFrames.mid;
	
	for i = 1, max do
		local frame = RPT_ExtraFrames[i];
		RPT_RF_DBM_WipeInfo(frame.info);
		RPT_RF_EF_UpdateHealth(frame, frame.unit);
	end
end

function RPT_RF_Init_DBM()
	if DBM then
		print("[RPT_Raidframes]:Using DBM to detect bossfights!");
		
		-- hook restore function:
		local oldFunc = DBM.EndCombat;
		DBM.EndCombat = function(arg1,arg2,arg3)
				oldFunc(arg1,arg2,arg3);
				
				if RPT_RF_DBM_SaveFunc then
					RPT_RF_DBM_SaveFunc();
				end
				RPT_RF_DBM_SaveFunc = nil;
				
				-- verander de debufftrackers weer naar normaal:
				
				RPT_RF_InitTracker();
				
				-- wipe normal frames.
				for i=1, 40 do
					local info = RPT_RF_FrameInfo[i];
					RPT_RF_DBM_WipeInfo(info);
					RPT_RF_updateHealth(info.player);
				end
				
				
				
				table.wipe(RPT_Debuffs2);
				collectgarbage();
			end
	else
		print("Special Debuff Tracting Deactivated due no DBM addon.");
	end
end

function RPT_RF_Hook_DBM(name,func)
	local mod = DBM:GetModByName(name);
	local oldFunc = mod.OnCombatStart;
	mod.OnCombatStart = function(md,delay)
			if oldFunc then
				oldFunc(md,delay);
			end
			func();
		end
end

function RPT_RF_DBM_Debuff(nr,lvl,sid,flash,func1,func2, duration)
	RPT_RF_ScanDebuffs = RPT_RF_ScanSpecialDebuffs;
	
	local name, texture;
	name, _ , texture = GetSpellInfo(sid);
	
	RPT_Debuffs2[name] = {};
	RPT_Debuffs2[name].name = name;
	RPT_Debuffs2[name].nr = nr;
	RPT_Debuffs2[name].lvl = lvl;
	RPT_Debuffs2[name].action = func1;
	RPT_Debuffs2[name].deactivate = func2;
	RPT_Debuffs2[name].texture = texture;
	RPT_Debuffs2[name].flash = flash;
	RPT_Debuffs2[name].duration = duration; -- duration is stored for emulating purposes.
	
	
	for i = 1, 40 do
		if lvl == 1 then
			local frame = getglobal("RPT_RF_Player"..i);
 			frame.B[nr].Texture:SetTexture(texture);
 		end
 		
 		RPT_RF_FrameInfo[i].debuffs[name] = 0;
	end
	
	local max = RPT_ExtraFrames.mid;
	
	for i = 1, max do
		local frame = RPT_ExtraFrames[i];
		
		if lvl == 1 then
 			frame.B[nr].Texture:SetTexture(texture);
 		end
 		
 		frame.info.debuffs[name] = 0;
	end
	
	return RPT_Debuffs2[name];
end

function RPT_RF_DBM_Link(name)
	-- link de events naar mijn constructoren:
	if name == "DBM-Icecrown" then
		RPT_RF_DBM_Link_Icecrown();
	elseif name == "DBM-Coliseum" then
		RPT_RF_DBM_Link_Coliseum();
	elseif name == "DBM-Ulduar" then
		RPT_RF_DBM_Link_Ulduar();
	end
end

----------------------------------
--       TESTING TOOLS          --
----------------------------------

RPT_T_DBM_Mod = false;
function RPT_T_Slash(msg)
	--msg = string.lower(msg);
	local c1,rest = msg:match("^(%S*)%s*(.-)$");

	if c1 == "on" then
		RPT_T_On();
	elseif c1 == "off" then
		 RPT_T_Off();
	elseif c1 == "agro" then
		RPT_T_SetAgro(rest);
	elseif c1 == "add" then
		local c2,rest2 = rest:match("^(%S*)%s*(.-)$");
		local c3,rest3 = rest2:match("^(%S*)%s*(.-)$");
		local c4,rest4 = rest3:match("^(%S*)%s*(.-)$");
		
		local name = UnitName(c2);
		print("name:"..c2);
		if name and c3 and c4 then
			local d1 = 1 * c3;
			local d2 = 1 * c4;
			print("scan for debuffs!");
			for k,v in pairs(RPT_Debuffs2) do
				if v.nr == d1 and v.lvl == d2 then
					local info = RPT_T_Debuffs[name];
					if not info then
						print("add new entry");
						RPT_T_Debuffs[name] = {};
						info = RPT_T_Debuffs[name];
					end
					
					local info2 = info[v.name];
					
					if not info2 then
						info[v.name] = {};
						info2 = info[v.name];
						info2.name = v.name;
						info2.stack = 0;
					end 
					
					-- check of er een stack is
					local c5,rest5 = rest4:match("^(%S*)%s*(.-)$");
					
					if c5 ~= "" then
					  info2.stack = info2.stack + (1 * c5);
					else
					  info2.stack = info2.stack + 1; 	
					end
					
					-- update the duration:
					if v.duration then
						info2.expire = GetTime() + v.duration;
						print("set Duration: "..v.duration.." expire: "..info2.expire);
					else
						print(" no duration!");
						info2.expire = nil;
					end
					
					print(name.." get emulated"..(v.name));
				end 
			end
		end
	elseif c1 == "rem" then
		local c2,rest2 = rest:match("^(%S*)%s*(.-)$");
		local c3,rest3 = rest2:match("^(%S*)%s*(.-)$");
		local c4,rest4 = rest3:match("^(%S*)%s*(.-)$");
		
		local name = UnitName(c2);
		print("name:"..c2);
		if name and c3 and c4 then
			local d1 = 1 * c3;
			local d2 = 1 * c4;
			print("scan for debuffs!");
			for k,v in pairs(RPT_Debuffs2) do
				if v.nr == d1 and v.lvl == d2 then
					local info = RPT_T_Debuffs[name];
					if not info then
						return
					end
					
					table.wipe(info[v.name]);
					print(name.." get emulated "..(v.name).." removed");
				end 
			end
		end
	elseif c1 == "wipe" then
		table.wipe(RPT_T_Debuffs);
		table.wipe(RPT_T_Agro);
	elseif c1 == "run" then
		print("run "..rest);
		if not RPT_T_DBM_Mod then
			RPT_T_DBM_Mod = DBM:GetModByName( rest );
			if RPT_T_DBM_Mod then
				print("Bossfight "..rest.." emulated!");
				RPT_T_DBM_Mod:OnCombatStart(0);
			end
		end
	elseif c1 == "stop" then
		if RPT_T_DBM_Mod then
			print("Emulation ends!");
			table.wipe(RPT_T_Debuffs);
			DBM:EndCombat(mod,false);
			RPT_T_DBM_Mod = false;
		end
	end
	
end


RPT_T_Debuffs = {};

RPT_T_UDB_Old = UnitDebuff;
function RPT_T_UDB(unit,nr,...)
	local name = UnitName(unit);
	
	if not name then return nil; end
	
	local info = RPT_T_Debuffs[name];
	
	if info then
		local i = 0;
		local time = GetTime();
		
		for k,v in pairs(info) do
			i = i + 1;
			
			if v.expire and v.expire <= time then
				i = i - 1;
				v.stack = 0;
			elseif i == nr then
				local duration = 1000;
				local expireTime = v.expire;
				local info2 = RPT_Debuffs2[v.name];
				
				if info2 then
					duration = info2.duration;
					if not duration then
						duration = 0;
					end
				end
				return v.name, "", "Interface\\Icons\\INV_Misc_QuestionMark", v.stack, "", duration, expireTime, "player", nil;
			end
		end
		
		-- normale debuffs
		nr = nr - i;
	end
	
	return RPT_T_UDB_Old(unit,nr);
end

RPT_T_Fake = false;
RPT_T_UT_Old = nil; 
function RPT_T_On()
	print("faking debuffs on!");
	if not RPT_T_Fake then
		RPT_T_UDB_Old = UnitDebuff;
		RPT_T_UT_Old = UnitThreatSituation;
		UnitThreatSituation = RPT_T_UT;
		UnitDebuff = RPT_T_UDB;
		RPT_T_Fake = true;
	end
end

function RPT_T_Off()
	print("faking debuffs off!");
	UnitDebuff = RPT_T_UDB_Old;
	UnitThreatSituation = RPT_T_UT_Old;
	RPT_T_Fake = false;
end

RPT_T_Agro = {}
function RPT_T_UT(unit, ...)
	if RPT_T_Agro[unit] then
		return RPT_T_Agro[unit];
	else
		return RPT_T_UT_Old(unit, ...);
	end
end

function RPT_T_SetAgro(rest)
	local unit, lvl = rest:match("^(%S*)%s*(.-)$");
	if lvl == "nil" then
		lvl = nil;
	else
		lvl = 1*lvl;
	end
	RPT_T_Agro[unit] = lvl;
end