-- Detection of bosses is done by:

-- *********************************************************
-- **                  Deadly Boss Mods                   **
-- **            http://www.deadlybossmods.com            **
-- *********************************************************

-- This addon links the combatstart and combatend functions of DBM to determen which boss is been fighten.
-- Thanks to the detection system by 'Deadly Boss Mods', this addon can activate the debuffwatchers that are of intrest during the fight.
-- Unfortunatly my addon can only show 2 debuffs at the time so some debuffs share posistions with a priority system.

-- DBM links
function RPT_RF_DBM_Link_Coliseum()
	RPT_RF_Hook_DBM( "NorthrendBeasts" , RPT_RF_DMB_Northrend_Beasts );
	RPT_RF_Hook_DBM( "Jaraxxus" , RPT_RF_DMB_Jaraxxus );
	RPT_RF_Hook_DBM( "ValkTwins" , RPT_RF_DMB_TwinColoseum );
	RPT_RF_Hook_DBM( "Anub'arak_Coliseum" , RPT_RF_DMB_AnubArakColoseum );
end


-- local vars:

local ParaToxin = nil;
local BurnBile = nil;


-- Coloseum:

local func1 = function(unit,info) 
	if UnitIsUnit("player",unit) then
		ParaToxin.flash = true; 
	end
end

local func2 = function(unit,info) 
	if UnitIsUnit("player",unit) then 
		BurnBile.flash = true;
	end
end

local func3 = function(unit,info) 
	if UnitIsUnit("player",unit) then 
		BurnBile.flash = false;
		ParaToxin.flash = false;
	end
end

local func4 = function()
	table.wipe(ParaToxin);
	table.wipe(BurnBile);
	ParaToxin = nil;
	BurnBile = nil;
end

function RPT_RF_DMB_Northrend_Beasts()
	
	RPT_RF_DBM_Debuff(5,1, 67478 ,false,false,false,30); -- Impale
	
	ParaToxin = RPT_RF_DBM_Debuff(6,2, 67618,false,func2,func3,false); -- Paralytic Toxin
	BurnBile  = RPT_RF_DBM_Debuff(6,1, 67621,false,func1,func3,24); -- Burning Bile
	
	RPT_RF_DBM_SaveFunc = func4;
end

function RPT_RF_DMB_Jaraxxus()
	RPT_RF_DBM_Debuff(6,1, 66237, true,false,false,15); -- Incinerate Flesh
	RPT_RF_DBM_Debuff(5,1, 66197, false,false,false,6); -- Legion Flame
	
	-- hard mode: 
	RPT_RF_DBM_Debuff(5,2, 66209, true,false,false,12); -- Touch of Jaraxxus
	RPT_RF_DBM_Debuff(5,3, 66211, false,false,false,15); -- Curse of the Nether
end

function RPT_RF_DMB_AnubArakColoseum()
	RPT_RF_DBM_Debuff(5,1, 66013, true,false,false,18); -- Penetrating Cold
	RPT_RF_DBM_Debuff(6,2, 65775, false,false,false,60); -- Acid-Drenched Mandibles
	RPT_RF_DBM_Debuff(6,1, 67720, false,false,false,60); -- Expose Weakness
end

function RPT_RF_DMB_TwinColoseum()
	-- TODO: give flashes to players with wrong debuffs!
	RPT_RF_DBM_Debuff(5,1, 65686, false,false,false,false); -- Light Essence
	RPT_RF_DBM_Debuff(6,1, 65684, false,false,false,false); -- Dark Essence
	
	-- hard mode:
	RPT_RF_DBM_Debuff(6,2, 65950, false,false,false,20); -- Touch of Light
	RPT_RF_DBM_Debuff(5,2, 66001, false,false,false,20); -- Touch of Darkness
	
end
