-- Detection of bosses is done by:

-- *********************************************************
-- **                  Deadly Boss Mods                   **
-- **            http://www.deadlybossmods.com            **
-- *********************************************************

-- This addon links the combatstart and combatend functions of DBM to determen which boss is been fighten.
-- Thanks to the detection system by 'Deadly Boss Mods', this addon can activate the debuffwatchers that are of intrest during the fight.
-- Unfortunatly my addon can only show 2 debuffs at the time so some debuffs share posistions with a priority system.

-- DBM links
function RPT_RF_DBM_Link_Icecrown()

	-- lower spire:
	RPT_RF_Hook_DBM( "LordMarrowgar" , RPT_RF_DMB_LordMarrowgar );
	RPT_RF_Hook_DBM( "Deathwhisper" , RPT_RF_DMB_Deathwhisper );
	RPT_RF_Hook_DBM( "Deathbringer" , RPT_RF_DMB_Deathbringer );
	
	-- Plagueworks:
	RPT_RF_Hook_DBM( "Festergut" , RPT_RF_DMB_Festergut );
	RPT_RF_Hook_DBM( "Rotface" , RPT_RF_DMB_Rotface );
	RPT_RF_Hook_DBM( "Putricide" , RPT_RF_DMB_Putricide );
	
	-- The Crimson halls:
	RPT_RF_Hook_DBM( "BPCouncil" , RPT_RF_DMB_BPCouncil );
	RPT_RF_Hook_DBM( "Lanathel" , RPT_RF_DMB_Lanathel );
	
	-- Frostwing halls
	RPT_RF_Hook_DBM( "Valithria" , RPT_RF_DMB_Valithria );
	RPT_RF_Hook_DBM( "Sindragosa" , RPT_RF_DMB_Sindragosa );
	
	-- Lich king
	RPT_RF_Hook_DBM( "LichKing" , RPT_RF_DMB_LichKing );
end

-- show that unit is possed!
local function1 = function(unit, dInfo, stack, info)
	info.showHealth = false;
	info.frame.Dead:SetTextColor(1,0,0);
	info.frame.Dead:SetText("HOSTILE");
end

local function2 = function(unit, dInfo, info)
	info.showHealth = true;
	info.frame.Dead:SetTextColor(1,1,1);
	RPT_RF_updateHealth(unit);
end

-- lower spire:

function RPT_RF_DMB_LordMarrowgar()
	RPT_RF_DBM_Debuff(5,1, 70823 ,true,false,false,3); -- Cold Flame, no evidence
	
	RPT_RF_DBM_Debuff(6,1, 69075 ,false,false,false,15); -- Bone Storm could be buff on boss
	
	RPT_RF_DBM_Debuff(5,2, 69065 ,true,false,false,false); -- Impaled
end

function RPT_RF_DMB_Deathwhisper()
	
	-- set dispelable debuff watchers:
	local nr = 2;
	
	if RPT_RF_DISPEL_Disease then
		RPT_RF_DBM_Debuff(6,2, 71129 ,true,false,false,15); -- Frost Fever
		nr = 3;
	end
	
	if RPT_RF_DISPEL_Curse then
		RPT_RF_DBM_Debuff(6,nr,71237,true,false,false,15); -- Curse of Torpor
		nr = 4;
	end
	
	RPT_RF_DBM_Debuff(6,1,70659,false,false,false,20); -- Necrotic Strike
	
	if nr == 2 then
		RPT_RF_DBM_Debuff(6,1, 71204 ,false,false,false,30); -- Touch of Insignificance
		RPT_RF_DBM_Debuff(5,1, 71289 ,false,function1,function2,20); -- Dominate Mind
	else
		RPT_RF_DBM_Debuff(5,1, 71204 ,false,false,false,30); -- Touch of Insignificance
		RPT_RF_DBM_Debuff(5,2, 71289 ,false,function1,function2,20); -- Dominate Mind
	end
end

function RPT_RF_DMB_Deathbringer()
	RPT_RF_DBM_Debuff(5,1, 72442 ,false,false,false,24); -- Boiling Blood
	RPT_RF_DBM_Debuff(5,2, 72408 ,false,false,false,false); -- Rune of Blood
	RPT_RF_DBM_Debuff(6,2, 72255 ,true,false,false,false); -- Mark of the Fallen Champion
end

-- Plague works:

function RPT_RF_DMB_Festergut()
	RPT_RF_DBM_Debuff(5,1, 69279 ,false,false,false,12); -- Gas Spore
	RPT_RF_DBM_Debuff(6,1, 71218 ,true,false,false,12); -- Vile Gas
end

function RPT_RF_DMB_Rotface()
	RPT_RF_DBM_Debuff(5,1, 71215 ,false,false,false,5); -- Ooze Flood
	RPT_RF_DBM_Debuff(6,1, 71224 ,true,false,false,12); -- Mutated Infection
end

function RPT_RF_DMB_Putricide()

	RPT_RF_DBM_Debuff(5,1, 70672 ,false,false,false,false); -- Gaseous Bloat
	RPT_RF_DBM_Debuff(6,1, 71278 ,false,false,false,15); -- Choking Gas
	RPT_RF_DBM_Debuff(6,2, 71279 ,false,false,false,20); -- Choking Gas Explosion
	RPT_RF_DBM_Debuff(6,3, 70447 ,true,false,false,false); -- Ooze Adhesive
end

-- The Crimson halls:

function RPT_RF_DMB_BPCouncil()
	RPT_RF_DBM_Debuff(5,1, 72796 ,true,false,false,8); -- Glittering Sparks
	RPT_RF_DBM_Debuff(6,1, 71822 ,false,false,false,false); -- Shadow Resonance
	
	-- wish I could tracked more...
end

function RPT_RF_DMB_Lanathel()
	-- Lol thought 2 spaces for debufs where enough for most fights XD
	RPT_RF_DBM_Debuff(5,1, 70821 ,false,false,false,false); -- Blood Mirror
	RPT_RF_DBM_Debuff(5,2, 71340 ,true,false,false,false); -- Pact of the Darkfallen
	RPT_RF_DBM_Debuff(5,3, 70986 ,false,false,false,false); -- Shroud of Sorrow
	
	RPT_RF_DBM_Debuff(6,1, 71625 ,false,false,false,15); -- Delirious Slash
	RPT_RF_DBM_Debuff(6,2, 70867 ,false,false,false,60); -- Essence of the Blood Queen
	RPT_RF_DBM_Debuff(6,3, 71474 ,false,false,false,10); -- Frenzied Bloodthirst
	RPT_RF_DBM_Debuff(6,4, 70923 ,false,function1,function2,false); -- spell_shadow_charm Uncontrollable Frenzy
	
	
end

-- Frostwing halls

function RPT_RF_DMB_Valithria()
	RPT_RF_DBM_Debuff(5,1, 71738 ,false,false,false,6); -- Corrosion
	
	RPT_RF_DBM_Debuff(6,1, 71733 ,false,false,false,20); -- Acid Burst
	RPT_RF_DBM_Debuff(6,2, 71283 ,true,false,false,12); -- Gut Spray (Disease)
end

function RPT_RF_DMB_Sindragosa()
	-- need confirmation about mechanics, hopefully this is usefull.

	RPT_RF_DBM_Debuff(5,1, 70106 ,false,false,false,8); -- chilled to the bone. (mellee, need confirmation)	
	RPT_RF_DBM_Debuff(5,2, 69766 ,false,false,false,8); -- instability (spellcasters)

	RPT_RF_DBM_Debuff(6,1, 70127 ,false,false,false,8); -- Mystic Buffet
	RPT_RF_DBM_Debuff(6,2, 70126 ,true,false,false,7); -- Frost Beacon
	RPT_RF_DBM_Debuff(6,3, 71665 ,true,false,false,false); -- Asphyxiation
	
end

function RPT_RF_DMB_LichKing()
	-- Never done the fight but this I think are good places to put them
	-- the upper debuff are dispellable and the plague must be distpelled below you must heal the targets much if flashes.
	
	RPT_RF_DBM_Debuff(5,1, 69397 ,false,false,false,8); -- Soul Rip
	RPT_RF_DBM_Debuff(5,2, 70337 ,true,false,false,15); -- Necrotic Plague
	
	
	RPT_RF_DBM_Debuff(6,1, 72133 ,false,false,false,3); -- Pain and Suffering
	RPT_RF_DBM_Debuff(6,2, 68980 ,true,false,false,5); -- Soul Reaper
	RPT_RF_DBM_Debuff(6,3, 69409 ,true,false,false,5); -- Soul Reaper
	RPT_RF_DBM_Debuff(6,4, 70541 ,true,false,false,false); -- Infest
	
end