-- First some code to handle frames, should move it....

local RPT_Extraframes = 0;

-- table containing the frames:\
RPT_ExtraFrames = {};
RPT_ExtraFrames.mid = 0;

function RPT_RF_EF_ActivateTargetFrame(bool)
	if not InCombatLockdown() then
		if bool then
			-- show frame:
			RPT_RF_TARGETFRAME:SetAttribute("unit","target");
			
			TargetFrame:Hide();
			
			-- check or the frame can be anchored to the targetframe
			RPT_RF_TARGETFRAME:SetPoint("TOPLEFT",nil,430,-30);
			
			RPT_RF_ActiveSettings.targetframe.active = true;
			
			TargetFrame:UnregisterEvent("PLAYER_TARGET_CHANGED");
			TargetFrame:UnregisterEvent("PLAYER_ENTERING_WORLD");
			RPT_RF_EF_UpdateFrame(RPT_RF_TARGETFRAME);
			
		else
			RPT_RF_TARGETFRAME:SetAttribute("unit",nil);
			
			RPT_RF_TARGETFRAME:Hide();
			
			RPT_RF_ActiveSettings.targetframe.active = false;
			
			-- bypass eventlisting.
			TargetFrame:RegisterEvent("PLAYER_TARGET_CHANGED");
			TargetFrame:RegisterEvent("PLAYER_ENTERING_WORLD");
			TargetFrame:OnEvent("PLAYER_ENTERING_WORLD");
		end
	end
end

function RPT_RF_EF_ActivateFocusFrame(bool)
	if not InCombatLockdown() then
		if bool then
			-- show frame:
			RPT_RF_FOCUSFRAME:SetAttribute("unit","focus");
			
			FocusFrame:Hide();
			
			-- check or the frame can be anchored to the focusframe
			local a,f,b,x,y = FocusFrame:GetPoint();
			
			if f ~= RPT_RF_FOCUSFRAME and not RPT_RF_ActiveSettings.focusframe.active then
				RPT_RF_FOCUSFRAME:ClearAllPoints();
				RPT_RF_FOCUSFRAME:SetPoint("TOPLEFT",FocusFrame,"TOPLEFT",0,0);
			end
			
			RPT_RF_ActiveSettings.focusframe.active = true;
			
			FocusFrame:UnregisterEvent("PLAYER_FOCUS_CHANGED");
			FocusFrame:UnregisterEvent("PLAYER_ENTERING_WORLD");
			RPT_RF_EF_UpdateFrame(RPT_RF_FOCUSFRAME);
			
		else
			RPT_RF_FOCUSFRAME:SetAttribute("unit",nil);
			
			RPT_RF_FOCUSFRAME:Hide();
			
			
			-- check or the frame can be anchored to the focusframe
			local a,f,b,x,y = RPT_RF_FOCUSFRAME:GetPoint();
			
			if f ~= FocusFrame and RPT_RF_ActiveSettings.focusframe.active then
				FocusFrame:ClearAllPoints();
				FocusFrame:SetPoint("TOPLEFT",RPT_RF_FOCUSFRAME,"TOPLEFT",0,0);
			end
			
			RPT_RF_ActiveSettings.focusframe.active = false;
			
			-- bypass eventlisting.
			FocusFrame:RegisterEvent("PLAYER_FOCUS_CHANGED");
			FocusFrame:RegisterEvent("PLAYER_ENTERING_WORLD");
			FocusFrame:OnEvent("PLAYER_ENTERING_WORLD");
		end
	end
end

function RPT_RF_EF_Register(frame)
	RPT_ExtraFrames.mid = RPT_ExtraFrames.mid + 1;
	RPT_ExtraFrames[RPT_ExtraFrames.mid] = frame;
	frame.RPT_FID = RPT_ExtraFrames.mid;
end

function RPT_RF_EF_Unregister(frame)
	if frame.RPT_FID then
		local fid = frame.RPT_FID;
		
		if fid < RPT_ExtraFrames.mid then 
			local frame2 = RPT_ExtraFrames[RPT_ExtraFrames.mid];
			RPT_ExtraFrames[fid] = frame2;
			frame2.RPT_FID = fid;
		elseif fid > RPT_ExtraFrames.mid then
			return;	
		end
		
		RPT_ExtraFrames.mid = RPT_ExtraFrames.mid - 1;
		frame.RPT_FID = nil;
	end
end

function extraframesUpdate( frame, time )
	frame.timer = frame.timer + time;
	
	-- do aura checks: (more often then raid checks.)
	if frame.timer > 0.2 then
		frame.timer = frame.timer - 0.2;
		
		-- incase of lagg.
		if frame.timer > 0.2 then
			frame.timer = 0;
		end
		
		if UnitExists(frame.unit) then
			frame:Update();
		end
		
		-- update ToT.
		if UnitExists(frame.ToT.unit) then
			local tot = frame.ToT.unit;
			local f2 = frame.ToT;
			f2.Name:SetText(UnitName(tot));
			
			f2.HP:SetMinMaxValues(0,UnitHealthMax(tot));
			f2.HP:SetValue(UnitHealth(tot));
			
			f2.MP:SetMinMaxValues(0,UnitPowerMax(tot));
			f2.MP:SetValue(UnitPower(tot));
		end
	end
	
	RPT_RF_EF_Flash(frame);
end 


local function RPT_RF_EF_FormatHealth(health)
	
	if health < 10000000 then
		if health < 100000 then
			if health < 10000 then
				return ""..health
			else
				return string.format("%.1f K", health/1000);
			end
		else
			return string.format("%.0f K", health/1000);
		end
	else
		if health < 100000000 then
			return string.format("%.1f M", health/1000000);
		else
			if health < 10000000000 then
				return ""..health
			else
				return tring.format("%.1f G", health/1000000000);
			end
		end
	end
	
end


function RPT_RF_InitExtraFrame(frame, unit)
	
	local frameName = frame:GetName();
	RPT_RF_EF_Register(frame);
	frame:SetScript("OnUpdate",extraframesUpdate);
	frame.timer = 0;
	
	-- make a fake agro screen:
	frame.Agro = {};
	frame.Agro.Hide = RPT_NILFUNCTION;
	frame.Agro.Show = RPT_NILFUNCTION;
	frame.Agro.frame = frame;
	frame.Agro.SetTexture = function(agro,r,g,b)
		RPT_RF_EF_SetBorderColor(agro.frame,r,g,b);
	end
		
	-- init some referance:
	frame.main = getglobal(frameName.."Main");
	frame.port = getglobal(frameName.."Port");
	frame.unit = unit;
	
	frame.port.parent = frame;
	frame.port.unit = unit;
	frame.port.raidtarget = getglobal(frameName.."PortRaidTargetIcon");
	
	frame.main.parent = frame;
	frame.main.unit = unit;
	
	frame.port.portrait = getglobal(frameName.."PortIcon2");
	frame.portrait = frame.port.portrait;
	
	frame.HP = getglobal(frameName.."HP");
	frame.HP:EnableMouse(false);
	frame.HPText = getglobal(frameName.."HP_Text");
	
	-- Dirty fix for the time been.
	frame.Death = frame.HPText;
	
	frame.MP = getglobal(frameName.."MP");
	frame.MP:EnableMouse(false);
	
	--frame.main:Raise();
	frame.port:Raise();
	
	frame.guid = UnitGUID(unit);
	
	frame.border1 = getglobal(frameName.."PortIcon1");
	frame.border2 = getglobal(frameName.."MainIcon1");
	frame.border1:SetTexCoord( 1, 0 , 0, 1 );
	frame.border2:SetTexCoord( 0, (271/512) ,  0, 1 );
	
	frame.castbar = getglobal(frameName.."MainCasting");
	frame.castbar.unit = unit;
	frame.border3 = getglobal(frameName.."MainCastingBorder");
	frame.border3:SetTexCoord( 0, (271/512) ,  0, (42/64) );
	
	frame.tile1 = getglobal(frameName.."MainTile1");
	frame.tile1:SetTexCoord( 0, 1, 0, (44/64) );
	
	frame.tile2 	= getglobal(frameName.."MainTile2");
	
	frame.tile1Icon = getglobal(frameName.."MainTile1Icon");
	frame.tile1Txt  = getglobal(frameName.."MainTile1Txt");
	
	frame.B = {}
	-- init debuffs
	for i = 1, 8 do
		frame.B[i] = getglobal( frameName.."MainB"..i );
		frame.B[i].Cd:SetCooldown(0,0);
		frame.B[i].Cd:Hide();
	end
	
	frame.Name = getglobal( frameName.."Main_Name");
	
	-- create a fake Dead textfield
	-- I must try to fix this more nicely.
	frame.Dead = {}
	frame.Dead.SetTextColor = RPT_NILFUNCTION;
	frame.Dead.SetText = RPT_NILFUNCTION;
	
	
	-- init portrait:
	SetPortraitTexture(frame.port.portrait , unit);
	
	-- init tot
	
	frame.ToT = getglobal(frameName.."PortToT");
	RegisterUnitWatch(frame.ToT);
	frame.ToT.unit = unit.."target";
	frame.ToT:RegisterForClicks("LeftButtonDown", "RightButtonDown");
	frame.ToT:SetAttribute("unit", frame.ToT.unit);
	frame.ToT:SetAttribute("*type1", "target");
	
	
	-- init click listening
	frame.hideStatusOnTooltip = true;
	RegisterUnitWatch(frame);
	frame:RegisterForClicks("LeftButtonDown", "RightButtonDown");
	--frame:SetAttribute("unit", unit);
	frame:SetAttribute("*type1", "target");
	frame:SetAttribute("*type2", "menu");
	frame.hideStatusOnTooltip = true;
	
	-- init info
	frame.info = 			{	
								frame			= frame,
								debuffs			= {}, --stackcounter debuffs.
								auraName		= {"", "", "", "", "", "", "", ""}, -- last texture used.
								range   		= false,
								showHealth		= true,
								dead    		= false,
								agro    		= 0,
								online  		= true,
								job     		= 0,
								flash   		= false, -- quick accesable boolean.
								flash_agro   	= false,
								flash_debuff	= false,
								flash_r 		= 0,
								flash_b 		= 0 };
	
	-- init events
	RPT_RF_INIT_EF_Events(frame);
	
	RPT_RF_EF_UpdateFrame(frame);
end

function RPT_RF_INIT_EF_Events(frame)
	local port = frame.port;
	local main = frame.main;
	
	port:SetScript("OnEvent", RPT_RF_EF_OnEvent1);
	main:SetScript("OnEvent", RPT_RF_EF_OnEvent2);
	-- port events:
	port:UnregisterAllEvents();
	port:RegisterEvent("UNIT_NAME_UPDATE");
	port:RegisterEvent("UNIT_PORTRAIT_UPDATE");
	port:RegisterEvent("UNIT_FACTION");
	port:RegisterEvent("UNIT_CLASSIFICATION_CHANGED");
	port:RegisterEvent("RAID_TARGET_UPDATE");
	
	if frame.unit == "focus" then
		port.unitSwitch = "PLAYER_FOCUS_CHANGED"
	elseif frame.unit == "target" then
		port.unitSwitch = "PLAYER_TARGET_CHANGED"
	end
	
	port:RegisterEvent(port.unitSwitch)
	-- switch
	
	
	-- main events:
	
	main:UnregisterAllEvents();
	main:RegisterEvent("UNIT_HEALTH");
	main:RegisterEvent("UNIT_DISPLAYPOWER");
	main:RegisterEvent("UNIT_MAXHEALTH");
	
	
end

function RPT_RF_EF_SetBorderColor(frame, r,g,b)
	frame.border1:SetVertexColor(r,g,b);
	frame.border2:SetVertexColor(r,g,b);
	frame.border3:SetVertexColor(r,g,b);
end

function RPT_RF_EF_UpdateFrame(frame)
	
	local unit = frame.unit;
	
	-- Set Portrait
	SetPortraitTexture(frame.portrait , frame.unit);
	frame.Name:SetText(UnitName(unit));
	
	-- Set mana
	frame.MP:SetMinMaxValues(0,UnitPowerMax(unit));
	frame.MP:SetValue(UnitPower(unit));
	RPT_RF_SetUnitManaBarColor(unit,frame.MP);
	
	-- Set hp
	local hMax = UnitHealthMax(unit)
	frame.healthMax = " / "..RPT_RF_EF_FormatHealth(hMax);
	frame.HP:SetMinMaxValues(0,hMax);
	RPT_RF_EF_UpdateHealth(frame, unit);
	
	-- check or its an enemy or a friend
	frame.info.agro = 10;
	RPT_RF_EF_SetTile1(frame, unit);
	
	local friendly = UnitIsFriend( "player", unit );
	--local charmedSelf = UnitIsCharmed( "player" );
	--local charmed = UnitIsCharmed( unit );
	
	if friendly then
		frame.Update = RPT_RF_EF_UpdateFriendFrame;
		frame.friendly = true;
	else
		frame.Update = RPT_RF_EF_UpdateEnemyFrame;
		frame.friendly = false;
	end
	
	-- updateCasting()
	RPT_RF_EF_CB_Reset(frame.castbar, unit);
	
	-- check raid target
	RPT_RF_EF_CheckRaidTarget(frame.port);
end

function RPT_RF_EF_UpdateCommenFrame(frame,unit)
	frame.MP:SetMinMaxValues(0,UnitPowerMax(unit));
	frame.MP:SetValue(UnitPower(unit));
	
	RPT_RF_EF_UpdateAgro(frame, unit);
end

function RPT_RF_EF_UpdateAuras(frame,hide)
	
	local playerInf = frame.info;
	
	for i = 1, 8 do
		local Finfo = RPT_RF_T_Buff_Inf[i];
		
		if Finfo.lvl > 0 then
			-- set the frame:
			frame.B[i]:SetAlpha(1);
			frame.B[i]:Show();
			if Finfo.duration and Finfo.duration > 0 then
				frame.B[i].Cd:Show();
				frame.B[i].Cd:SetCooldown( Finfo.timer - Finfo.duration , Finfo.duration);
			else
				--frame.B[i].Cd:SetCooldown(GetTime(),0);
				frame.B[i].Cd:Hide();
			end
			
			if Finfo.info.texture ~= playerInf.auraName[i] then
				playerInf.auraName[i] = Finfo.info.texture;
				frame.B[i].Texture:SetTexture(Finfo.info.texture);
			end
			
			if Finfo.stack > 1 then
				frame.B[i].Stack:SetText(Finfo.stack);
			else
				frame.B[i].Stack:SetText("");
			end
		else
			-- deactivates the frames.
			frame.B[i].Stack:SetText("");
			frame.B[i].Cd:SetCooldown(GetTime(),0);
			
			if hide then
				frame.B[i]:Hide();	
			end
			
			frame.B[i]:SetAlpha(0.2);
		end
	end
end

function RPT_RF_EF_UpdateFriendFrame(frame)
	local unit = frame.unit;
	RPT_RF_EF_UpdateCommenFrame(frame,unit);
	
	-- resets the aura Table:
	for i = 1, 8 do
		RPT_RF_T_Buff_Inf[i].lvl = 0;
	end
	
	if RPT_Healing then
		RPT_RF_FriendlyAuras1(frame,unit);
	else
		RPT_RF_FriendlyAuras2(frame,unit);
	end
	
	RPT_RF_EF_UpdateAuras(frame,true);
	
end

function RPT_RF_EF_UpdateEnemyFrame(frame)
	local unit = frame.unit;
	RPT_RF_EF_UpdateCommenFrame(frame,unit);
	
	-- resets the aura Table:
	for i = 1, 8 do
		RPT_RF_T_Buff_Inf[i].lvl = 0;
	end
	
	RPT_RF_EnemyAuras1(frame, unit);
	RPT_RF_EF_UpdateAuras(frame,true);
end


function RPT_RF_EF_UpdateHealth(frame, unit)
	-- todo: make it posible to die.
	-- todo: integrate raidwatcher in it.
	
	local health = UnitHealth(unit);
	frame.HP:SetValue(health);
	
	frame.HPText:SetText( RPT_RF_EF_FormatHealth(health)..(frame.healthMax));
end



function RPT_RF_EF_OnEvent1( frame, event, unit)

	if event == "UNIT_PORTRAIT_UPDATE" and unit == frame.unit then
		SetPortraitTexture(frame.portrait , unit);
	elseif event == frame.unitSwitch then
		RPT_RF_EF_UpdateFrame(frame.parent);
	elseif event == "RAID_TARGET_UPDATE" then
		RPT_RF_EF_CheckRaidTarget(frame);
	elseif event == "UNIT_FACTION" and unit == frame.unit then
		 RPT_RF_EF_SetTile1(frame.parent, unit);
	elseif event == "UNIT_CLASSIFICATION_CHANGED" and unit == frame.unit then
		RPT_RF_EF_UpdateFrame(frame.parent);
	end

end

function RPT_RF_EF_OnEvent2( frame, event, unit)
	
	if unit == frame.unit then
		
		-- get the information frame.
		frame = frame.parent;
		
		if event == "UNIT_HEALTH" then
			RPT_RF_EF_UpdateHealth(frame, unit);
		elseif event == "UNIT_MAXHEALTH" then
			local hMax = UnitHealthMax(unit)
			frame.healthMax = " / "..RPT_RF_EF_FormatHealth(hMax);
			frame.HP:SetMinMaxValues(0,hMax);
			RPT_RF_EF_UpdateHealth(frame, unit);
		elseif event == "UNIT_DISPLAYPOWER" then
			frame.MP:SetMinMaxValues(0,UnitPowerMax(unit));
			frame.MP:SetValue(UnitPower(unit));
			RPT_RF_SetUnitManaBarColor(unit,frame.MP);
		end
	end
end

-- copied from Targetframe
function RPT_RF_EF_UpdateAgro(frame, unit )
	
	local info = frame.info;
	local agro,r,g,b;
	if frame.friendly then
		agro = UnitThreatSituation(unit);
		r,g,b = GetThreatStatusColor(agro);
	else
		local Tpct;
		_, agro, Tpct, _, _ = UnitDetailedThreatSituation("player", unit);
		r,g,b = GetThreatStatusColor(agro);
		if not Tpct then Tpct = 0; end
		
		Tpct = string.format("%.0f", Tpct);
		if frame.agro then
		 frame.tile1Txt:SetText(Tpct.."%");
		 	if info.agro ~= agro then
		 		frame.tile1:SetVertexColor(r,g,b);
		 	end
		end
	end
	
	if not agro then
		agro = 0;
	end
	
	if info.agro ~= agro then
		
		info.agro = agro;	
		
		
		if agro == 0 and not info.flash_debuff then
			RPT_RF_EF_SetBorderColor(frame, 1, 1, 1);
		end
		
		RPT_RF_EF_SetBorderColor(frame,r,g,b);
		
		if agro == 3 then
			info.flash = true;
			info.flash_agro = true;
			info.flash_r = 1;
		else
			info.flash_agro = false;
			
			if not info.flash_debuff then
				--print("flash deactivated!");
				info.flash = false;
			end
			
			info.flash_r = 0;
		end
	end
end

function RPT_RF_EF_Flash(frame)
	local info = frame.info;
	if info and info.flash then
		RPT_RF_EF_SetBorderColor(frame, info.flash_r,rpt_rf_flash_Timer,info.flash_b);
	end
end

function RPT_RF_EF_SetTile1(frame, unit)

	frame.agro = false;
	frame.pvp = false;
	
	-- set nameplate color 
	if ( not UnitPlayerControlled(unit) and UnitIsTapped(unit) and not UnitIsTappedByPlayer(unit) and not UnitIsTappedByAllThreatList(unit) ) then
		frame.tile2:SetVertexColor(0.5, 0.5, 0.5);
	else
		frame.tile2:SetVertexColor(UnitSelectionColor(unit));
	end
	
	local factionGroup = UnitFactionGroup(unit);
	if UnitIsPVPFreeForAll(unit)  then
		frame.pvp = true;
		frame.tile1Txt:Hide();
		frame.tile1Icon:SetTexture("Interface\\TargetingFrame\\UI-PVP-FFA");
		frame.tile1:SetVertexColor(1,1,0);
		frame.tile1Icon:Show();
		
	elseif factionGroup and UnitIsPVP( unit ) then
		frame.pvp = true;
		
		frame.tile1Txt:Hide();
		frame.tile1Icon:Show();
		frame.tile1Icon:SetTexture("Interface\\TargetingFrame\\UI-PVP-"..factionGroup);
		
		if (factionGroup == "Alliance") then
			frame.tile1:SetVertexColor(0,0,0.65);
		else
			frame.tile1:SetVertexColor(0.65,0,0);
		end
	elseif  not UnitIsFriend("player",unit) then
		
		frame.tile1Icon:Hide();
		
		if UnitPlayerControlled(unit) then
			-- target is enemy player
			frame.tile1Txt:Hide();
		else
			-- target is enemy.
			frame.agro = true;
			frame.tile1Txt:Show();
		end
	else
		frame.tile1Icon:Hide();
		frame.tile1Txt:Hide();
		frame.tile1:SetVertexColor(0.2,0.2,0.2)
	end
end

function RPT_RF_FriendlyAuras2(frame, target)
	
	local name, rank, icon, count, debuffType, duration, expirationTime, caster, isStealable;
	local nr;
	for i=1, 6 do
		if i >= 5 then
		 nr = i + 2;
		else
		 nr = i;
		end
		
		name, rank, icon, count, debuffType, duration, timer, caster, isStealable = UnitBuff(target, i);
		if not name then break; end
		
		RPT_RF_T_Buff_Inf[nr].lvl 		= 1
		RPT_RF_T_Buff_Inf[nr].info 		= RPT_RF_T_TMP_INF[i]
		RPT_RF_T_Buff_Inf[nr].info.texture = icon;
		RPT_RF_T_Buff_Inf[nr].timer 	= timer;
		RPT_RF_T_Buff_Inf[nr].duration	= duration;
		RPT_RF_T_Buff_Inf[nr].stack		= count or 1;
	end
	
	for i = 5, 6 do
		name, rank, icon, count, debuffType, duration, timer, caster, isStealable = UnitDebuff(target, i-4);
		if not name then break; end
		
		RPT_RF_T_Buff_Inf[i].lvl 		= 1
		RPT_RF_T_Buff_Inf[i].info 		= RPT_RF_T_TMP_INF[i];
		RPT_RF_T_Buff_Inf[i].info.texture = icon;
		RPT_RF_T_Buff_Inf[i].timer 	= timer;
		RPT_RF_T_Buff_Inf[i].duration	= duration;
		RPT_RF_T_Buff_Inf[i].stack		= count or 1;
	end
end

function RPT_RF_EnemyAuras1(frame, target)
	
	local name, rank, icon, count, debuffType, duration, expirationTime, caster, isStealable;
	local nr;
	for i = 1, 6 do
		
		if i >= 5 then
		 nr = i + 2;
		else
		 nr = i;
		end
		
		name, rank, icon, count, debuffType, duration, timer, caster, isStealable = UnitDebuff(target, i);
		if not name then break; end
		
		RPT_RF_T_Buff_Inf[nr].lvl 		= 1
		RPT_RF_T_Buff_Inf[nr].info 		= RPT_RF_T_TMP_INF[i]
		RPT_RF_T_Buff_Inf[nr].info.texture = icon;
		RPT_RF_T_Buff_Inf[nr].timer 	= timer;
		RPT_RF_T_Buff_Inf[nr].duration	= duration;
		RPT_RF_T_Buff_Inf[nr].stack		= count or 1;
	end
	
	for i = 5, 6 do
		name, rank, icon, count, debuffType, duration, timer, caster, isStealable = UnitBuff(target, i-4);
		if not name then break; end
		
		RPT_RF_T_Buff_Inf[i].lvl 		= 1
		RPT_RF_T_Buff_Inf[i].info 		= RPT_RF_T_TMP_INF[i];
		RPT_RF_T_Buff_Inf[i].info.texture = icon;
		RPT_RF_T_Buff_Inf[i].timer 	= timer;
		RPT_RF_T_Buff_Inf[i].duration	= duration;
		RPT_RF_T_Buff_Inf[i].stack		= count or 1;
	end
end

function RPT_RF_FriendlyAuras1(frame, target)


	local buffnr = 1;
	local playerInf = frame.info;
	
	-- scan buffs and debuffs, curently only buffs.
	while(RPT_Healing)
	do
		local name, rank, texture, stack, kind, duration, timer, caster = UnitBuff(target,buffnr,1);
		buffnr = buffnr + 1;
		
		if not name then
			break;
		end
		-- only register your buffs
		
		if caster and UnitIsUnit("player",caster) then
			
			-- check or the buff is whatched:
			local bInfo = RPT_Buffs[name];
			
			if bInfo then
				local nr = bInfo.nr;
				
				-- check info priority
				if 	RPT_RF_T_Buff_Inf[nr].lvl < bInfo.lvl then
					-- store the info
					RPT_RF_T_Buff_Inf[nr].lvl 		= bInfo.lvl;
					RPT_RF_T_Buff_Inf[nr].info 		= bInfo;
					RPT_RF_T_Buff_Inf[nr].timer 	= timer;
					RPT_RF_T_Buff_Inf[nr].duration	= duration;
					RPT_RF_T_Buff_Inf[nr].stack		= stack;
				end 
			end
		end
	end;
	
	RPT_RF_ScanDebuffs(target,frame,playerInf);
	
	-- clear deactivated (de)buffs.
end


--- CastingBar
function RPT_RF_EF_CB_OnLoad(frame)
	frame:SetScript("OnUpdate", RPT_RF_EF_CB_OnUpdate);
	frame:SetScript("OnEvent",RPT_RF_EF_CB_OnEvent);
	
	-- update
	frame.update = RPT_NILFUNCTION;
	frame.castEnd = 0;
	frame.castD = 0;
	frame.castTime = 0;
	frame.progress = 0;
	frame.casting = false;
	frame.channeling = false;
	
	local frameName = frame:GetName();
	
	frame.icon = getglobal(frameName.."Icon");
	frame.bar = getglobal(frameName.."Bar");
	frame.text = getglobal(frameName.."Text");
	frame.spark = getglobal(frameName.."Spark");
	
	-- register events:
	frame:RegisterEvent("UNIT_SPELLCAST_START"); -- start spellcasting
	frame:RegisterEvent("UNIT_SPELLCAST_STOP"); -- when user stoped it.
	frame:RegisterEvent("UNIT_SPELLCAST_FAILED"); -- failed spellcasting:
	frame:RegisterEvent("UNIT_SPELLCAST_INTERRUPTED"); -- spellcasting interupted.
	frame:RegisterEvent("UNIT_SPELLCAST_DELAYED"); -- pushback
	
	frame:RegisterEvent("UNIT_SPELLCAST_CHANNEL_START"); -- start channel
	frame:RegisterEvent("UNIT_SPELLCAST_CHANNEL_UPDATE"); -- pushback I think.
	frame:RegisterEvent("UNIT_SPELLCAST_CHANNEL_STOP"); -- ?
	
	
	frame:RegisterEvent("UNIT_SPELLCAST_INTERRUPTIBLE");
	frame:RegisterEvent("UNIT_SPELLCAST_NOT_INTERRUPTIBLE ");
	
	frame:RegisterEvent("PLAYER_ENTERING_WORLD");
end

function RPT_RF_EF_CB_Reset(frame,unit)
	if not unit then return end;
	
	local casting = UnitCastingInfo(unit);
	local channeling = UnitChannelInfo(unit);
	
	if casting then
		RPT_RF_EF_CB_OnEvent(frame,"UNIT_SPELLCAST_START",unit)
	elseif channeling then
		RPT_RF_EF_CB_OnEvent(frame,"UNIT_SPELLCAST_CHANNEL_START",unit)
	else
		frame:Hide();
	end
end

function RPT_RF_EF_CB_StartCasting(frame,name,icon, cStart, cEnd, interupt)
	local now = GetTime();
	frame.bar:Show();
	frame.spark:Show();
	frame.canceled = false;
	
	cStart = cStart / 1000;
	cEnd = cEnd / 1000;
	
	local duration = cEnd - cStart;
	
	frame.castEnd = cEnd;
	frame.castD = 224 / duration;
	frame.progress = (now - cStart) * frame.castD;
	frame.icon:SetTexture(icon);
	frame.text:SetText(name);
	frame.fade = 1;
	
	frame:Show();
	frame:SetAlpha(1);
	
	
	if interupt then
		-- cannot interupt.
		frame.bar:SetTexture("Interface\\Addons\\RPT_Raidframes\\media\\bar2");
		frame.bar:SetVertexColor(0.1,0.5,0.7);
		frame.spark:SetVertexColor(0.1,0.5,0.7);
	else
		--print(" can interupt");
		frame.bar:SetTexture("Interface\\Addons\\RPT_Raidframes\\media\\bar");
		frame.bar:SetVertexColor(0.2,0.8,1);
		frame.spark:SetVertexColor(0.2,0.8,1);
	end
end

function RPT_RF_EF_CB_OnEvent(frame,event,unit, arg2, arg3, arg4)
	--print("event")
	if unit == frame.unit then --frame.unit then
		
		if event == "UNIT_SPELLCAST_START" then
			frame.update = RPT_RF_CB_UpdateCast;
			local name, _, _, icon, cStart, cEnd, _, castID, interupt = UnitCastingInfo(unit);
			 				
			frame.casting = true;
			frame.channeling = false;
			frame.castID = castID;
			
			RPT_RF_EF_CB_StartCasting(frame,name,icon, cStart, cEnd, interupt);
		elseif event == "UNIT_SPELLCAST_CHANNEL_START" then
			frame.update = RPT_RF_CB_UpdateCast;
			local name, _, _, icon, cStart, cEnd, _, interupt= UnitChannelInfo(unit);
				
			frame.channeling = true;
			frame.casting = false;
			
			RPT_RF_EF_CB_StartCasting(frame,name,icon, cStart, cEnd, interupt);
		elseif event == "UNIT_SPELLCAST_DELAYED" then
			local name, _, _, icon, cStart, cEnd, _, castID, interupt = UnitCastingInfo(unit);
			if not name then
				return;
			end
			
			cEnd = cEnd / 1000;
			
			-- calculate delay:
			local till = cEnd- GetTime();
			frame.castEnd = cEnd;
			frame.progress = 224 - till * frame.castD;
			
			-- repair if casting is stopped already.
			if not frame.casting then
				frame.bar:SetVertexColor(0.2,0.8,1);
				frame.spark:SetVertexColor(0.2,0.8,1);
				frame:SetAlpha(1);
			end
		elseif event == "UNIT_SPELLCAST_CHANNEL_UPDATE" then
			local name, _, _, icon, cStart, cEnd, _, interupt = UnitChannelInfo(unit);
			if not name then
				return;
			end
			
			cEnd = cEnd / 1000;
			
			-- calculate delay:
			local till = cEnd- GetTime();
			frame.castEnd = cEnd;
			frame.progress = 224 - till * frame.castD;
			
		elseif  event == "UNIT_SPELLCAST_STOP" or
				event == "UNIT_SPELLCAST_FAILED" or 
				event == "UNIT_SPELLCAST_INTERRUPTED"		 then
				
			if ( frame.casting and frame.castID == arg4 ) or frame.channeling then
				frame.update = RPT_RF_CB_UpdateDisapear;
				frame.bar:SetVertexColor(1,0,0);
				
				if event == "UNIT_SPELLCAST_FAILED" then
					frame.text:SetText(ACTION_SPELL_CAST_FAILED);
				else
					frame.text:SetText(ACTION_SPELL_INTERRUPT);
				end
				
				frame.spark:SetVertexColor(1,1,1);
				frame.canceled = true;
				frame.fade = 2;
			end
		elseif event == "UNIT_SPELLCAST_CHANNEL_STOP" then
			frame.update = RPT_RF_CB_UpdateDisapear;
			frame.bar:SetVertexColor(0,1,0);
			
			frame.text:SetText("finished");
			
			frame.spark:SetVertexColor(1,1,1);
			frame.canceled = false;
			frame.fade = 2;
		elseif event == "UNIT_SPELLCAST_INTERRUPTIBLE" then
			frame.bar:SetTexture("Interface\\Addons\\RPT_Raidframes\\media\\bar");
			frame.bar:SetVertexColor(0.2,0.8,1);
			frame.spark:SetVertexColor(0.2,0.8,1);
		elseif event == "UNIT_SPELLCAST_NOT_INTERRUPTIBLE" then
			frame.bar:SetTexture("Interface\\Addons\\RPT_Raidframes\\media\\bar2");
			frame.bar:SetVertexColor(0.1,0.5,0.7);
			frame.spark:SetVertexColor(0.1,0.5,0.7);
		end
		
	elseif (event == "PLAYER_ENTERING_WORLD") then
		RPT_RF_EF_CB_Reset(frame,frame.unit);
	end
end

function RPT_RF_EF_CB_OnUpdate(frame, elasped)
	frame.update(frame,elasped);
end

function RPT_RF_CB_UpdateCast(frame,elasped)
	
	local progress = frame.progress + ( frame.castD * elasped )
	
	if progress >= 224 then
		-- end of cast
		frame.update = RPT_RF_CB_UpdateDisapear;
		frame.bar:SetVertexColor(0,1,0);
		frame.spark:SetVertexColor(1,1,1);
		frame.fade = 2;
		progress = 224;
		
		frame.progress = progress;
	
		if frame.casting then
			frame.bar:SetWidth(progress);
			frame.spark:SetPoint("LEFT",frame, 10 + progress,0);
		elseif frame.channeling then
			frame.bar:Hide();
			frame.spark:SetPoint("LEFT",frame, 234 - progress,0);
		end
				
		frame.castID = nil;
		frame.casting = false;
		frame.channeling = false;
	end
	
	frame.progress = progress;
	
	if frame.casting then
		frame.bar:SetWidth(progress);
		frame.spark:SetPoint("LEFT",frame, 10 + progress,0);
	elseif frame.channeling then
		frame.bar:SetWidth( 224 - progress);
		frame.spark:SetPoint("LEFT",frame, 234 - progress,0);
	end
end

function RPT_RF_CB_UpdateDisapear(frame,elasped)
	local fade = frame.fade - 2 * elasped;
	frame.fade = fade;
	
	if fade > 1 then 
		frame.spark:SetPoint("LEFT",frame, 10 + (2-fade) * 224 ,0);
		return; 
	end
	
	--frame.spark:SetPoint("LEFT",frame, 224 ,0);
	if frame.spark:IsVisible()  then
		frame.spark:Hide();
	end
	
	if fade <= 0 then
		fade = 0;
		frame.update = RPT_NILFUNCTION;
		frame:Hide();
	end
	
	local fade2 = 1-fade;
	
	frame:SetAlpha(fade);
	if frame.canceled then
		frame.bar:SetVertexColor(1,fade2, fade2);
	else
		frame.bar:SetVertexColor(fade2,1, fade2);
	end
end

function RPT_RF_EF_CheckRaidTarget(frame)
	unit = frame.unit;
	
	local index = GetRaidTargetIndex(unit);
	if ( index ) then
		SetRaidTargetIconTexture(frame.raidtarget, index);
		frame.raidtarget:Show();
	else
		frame.raidtarget:Hide();
	end
end