function RPT_InitOptionpanel(panel)
	
	-- set the optionPanel in the options:
	panel.name = "RPT";
	panel.okay = RPT_OptionOk;
	panel.cancel = RPT_OptionCancel;
	InterfaceOptions_AddCategory(panel);
	
	-- set Handler:
	SLASH_RPT1 = "/rpt";
	SlashCmdList["RPT"] = RPT_Slashreader;
		

end


function RPT_OptionOk()
	-- go down the list
	RPT_RF_SaveSettings();
	
	if InCombatLockdown() then
     RPT_RF_Update = true;
	end
	
	if RPT_C2H_Loaded then
		RPT_CH_Accept_Changes();
	end
end

function RPT_OptionCancel()
	
	-- Undo changes.
	RPT_RF_ActivateSettings(RPT_RF_ActiveSettings);
	RPT_RF_OP_ShowSettings();
	
	if RPT_C2H_Loaded then
		RPT_CH_Cancel_Changes();
	end
end

function RPT_Slashreader(msg)
	InterfaceOptionsFrame_OpenToCategory(RPT_Optionpanel);
end

function RPT_OPT_CreateDropdown(name,frame,x,y,items,funct)
	local dropdown;
	
	if not _G[name] then
	   dropdown = CreateFrame("Frame", name, frame, "UIDropDownMenuTemplate");
	end
	
	dropdown.items = items;
	
	dropdown:ClearAllPoints()
	dropdown:SetPoint("TOPLEFT", frame, x, y);
	dropdown:Show();
	
	local function OnDropDownclick1(self)
	   local id = self:GetID();
	   UIDropDownMenu_SetSelectedID(dropdown, id);
	   funct(self);
	end
	
	local function initialize(self, level)
	   local info = UIDropDownMenu_CreateInfo()
	   for k,v in pairs(items) do
	      info = UIDropDownMenu_CreateInfo()
	      info.text = v
	      info.value = v
	      info.func = OnDropDownclick1
	      UIDropDownMenu_AddButton(info, level)
	   end
	end
	
	
	UIDropDownMenu_Initialize(dropdown, initialize)
	UIDropDownMenu_SetWidth(dropdown, 120);
	UIDropDownMenu_SetButtonWidth(dropdown, 144)
	UIDropDownMenu_SetSelectedID(dropdown, 1)
	UIDropDownMenu_JustifyText(dropdown, "LEFT")

end

function RPT_OPT_SetDropDownSelectedIDsafe(frame, id)
		UIDropDownMenu_SetSelectedID( frame, id);
		UIDropDownMenu_SetText(	frame, frame.items[id]);
end

function RPT_OPT_CreateSlider(name,frame,x,y,min,max,stap,txt,funct)
	local slider;
	
	if not _G[name] then
	   slider =  CreateFrame('Slider', name, frame, 'OptionsSliderTemplate');
	end
	
	-- text area
	
	local textbox = CreateFrame('EditBox', nil, slider,"RPT_EditBoxTemplate");
	textbox.mytype = "textbox";
	textbox:SetMaxLetters(10);
	textbox:SetWidth(120)
	textbox:SetHeight(25)
	textbox:SetAutoFocus(false)
	textbox:ClearFocus();
	textbox:Show();
	
	textbox:SetText("1");
	textbox.slider = slider;
	
	local funct1 = function(self)
	
		if self.surpress then
			self.surpress = false;
			return
		end
		local n = tonumber(self:GetText())
		local min, max = self.slider:GetMinMaxValues();
		
		if not n then
			-- try catching the number
			local s = string.match(self:GetText(), "[0-9]+.[0-9]*");
			if not s then 
				n = min;
				s = ""..min;
			else
				n = tonumber(s);
			end
			self:SetText(s);
		end

		
		if n < min then n = min self:SetText(n)
		elseif n > max then n = max self:SetText(n) end
		self.slider.surpress = true; 
		self.slider:SetValue(n);
		funct(n);
	end
	
	textbox:SetScript("OnTextSet", funct1 );
	
	textbox:SetScript("OnTextChanged", funct1);
	
	slider.textbox = textbox;
	
	textbox:ClearAllPoints();
	textbox:SetPoint("TOPLEFT",slider, 170,0,"InputBoxTemplate");
	
	slider:ClearAllPoints();
	slider:SetPoint("TOPLEFT", frame, x, y);
	slider:Show();
	
	slider:SetWidth(150);
	slider:SetHeight(20);

	slider:SetOrientation('HORIZONTAL');
 
 	getglobal(slider:GetName() .. 'Low'):SetText(""..min);
 	getglobal(slider:GetName() .. 'High'):SetText(""..max); 
 	getglobal(slider:GetName() .. 'Text'):SetText(txt);
	
	slider:SetMinMaxValues(min, max);
	slider:SetValueStep(stap) 
	slider:SetValue(1);
	
	slider:SetScript("OnValueChanged", function(self) 
		if self.surpress then 
			self.surpress = false;
		else 
			self.textbox.surpress = true;
			self.textbox:SetText(self:GetValue());
		end 
	end);
		
	slider:Show();


end